#ifndef MPRISDATAGETTER_H
#define MPRISDATAGETTER_H

#ifndef Q_WS_WIN

#include "trackmetainfo.h"
#include <QDBusAbstractInterface>
#include <QDBusInterface>
#include <QDBusConnection>
#include <QDBusReply>
#include <QDebug>
#include <QTest>
#include <QTimer>
#include <QVariant>

class MPRISDataGetter : public QObject
{
Q_OBJECT
public:
    MPRISDataGetter(QString player_name, int timer_period);
    ~MPRISDataGetter();
    bool isPlayingStopped();
    TrackMetaInfo getTrackMetaInfo();

private:
    QString m_player_name;
    QDBusInterface* m_dbus_interface;
    QDBusInterface* m_dbus_interface_tracklist;
    QString m_uri_call_method;
    QString m_length_call_method;
    QString m_artist_call_method;
    QString m_title_call_method;
    QString m_album_call_method;
    QString m_track_call_method;
    QString getURI();
    QString getArtist();
    QString getTitle();
    QTimer* m_timer;
    TrackMetaInfo getTrackMetaInfo(QVariantMap);
    TrackMetaInfo getTrackMetaInfo(QDBusReply<QVariantMap>);
    bool isPlayingStausChanged();
    bool m_was_stopped;
    QString m_current_uri;
    QString m_current_artist;
    QString m_current_title;

private slots:
    void trackChanged(int);
    void trackChanged(QVariantMap);
    void checkPlayerStatus();
    void isTrackChanged();
    void trackChanged(QString);
    void playerStatusChanged(bool);

signals:
    void trackChanged(TrackMetaInfo);
    void playingStoppedStatusChanged(bool);
};

#endif

#endif // MPRISDATAGETTER_H
